var SerialPort = require('serialport');// include the library
var myPort = new SerialPort('/dev/ttyUSB0', { autoOpen: false });
var fs = require('fs');
fs.open('dataout.txt', 'w', function (err, file) {
  if (err) throw err;});
// var readline = require('readline-sync');
var math = require('mathjs');

var i=0;
var j=0;
var k=0;
var sum=0;
var kk=0;
var a = new Array();
var lth = new Array();
var nval = new Array();
var xx,yy,xxn,yyn;
var time0=0;
var time1, rrtime;

// var ntot = readline.question("input ntot:  ");  //Input the number of bytes to be read

myPort.on('open', showPortOpen);
myPort.on('close', showPortClose);
myPort.on('error', showError);
myPort.on('data', readdata);


function readdata(data)
{
  i=i+1;                                     //Counts the number of times data is read
  a[i]= data.toString('hex');                //save data in hex format
  lth[i]= Buffer.byteLength(a[i],'utf8');    //save the length of the hex data
  sum=sum+lth[i];
  if (sum>=8)                          //Once 4 bytes have been read do
   {
    k=0;
    for(j=1;j<(i+1);j++)
     {
      for(kk=0;kk<lth[j];kk=kk+2)
      {
       xx=a[j].charCodeAt(kk);              //xx is the kk'th nibble
       yy=a[j].charCodeAt(kk+1);            //yy is the (kk+1)th nibble
       if (xx < 90) {xxn= xx-48}            //for nibble's that are 0-9
        else {xxn=xx-87};                   //for nibble's that are 10-15
       if (yy < 90) {yyn= yy-48} 
        else {yyn=yy-87};
       nval[k]=parseFloat(16*xxn+yyn);     //combine the two nibbles to make a byte (0-255)
       k=k+1;
      }
     }
      time1=nval[0]+256*nval[1]+256*256*nval[2]+256*256*256*nval[3];
      time1=time1*0.000002;
      rrtime=math.round(1000*(time1-time0),0);
      time0=time1;
       console.log(rrtime);             //print out the rrinterval
       fs.appendFileSync('dataout.txt',' '+rrtime+'\r');
//      }
//     fs.close('dataout.txt');
//     myPort.close(showPortClose());
    sum=0;
    i=0;
   }
}

function showPortOpen() {
   myPort.flush();
}


 function showPortClose() {
   console.log('port closed.');
}

function showError(error) {
   console.log('Serial port error: ' + error);
}

myPort.open(function (err) {
  if (err) {
    return console.log('Error opening port: ', err.message);
  }});


